function  [y_axis,Y_lims] = show_plot_of_RF_line(y_axis, Line_to_show,RF_frame,RF_frame_Q, flag, HEADER,scale_in_us, I_Q_show)
%% IN:
% y_axis - scanning depth axis, cm
% Line_to_show - number of RF line to display
% RF_frame, RF frame to show
% RF_frame_Q
% flag - turns dyspay of envelope on/off
% HEADER - header of RF data file
% scale_in_us - option for x-axis of dysplay (0 - in cm, 1 - in us and 2 - in samples)
%% OUT: 
% displays selected RF line in a plot
% y_axis - in selected units (time, depth or samples)

%flag2 = HEADER{1}.source_ID;

if (scale_in_us==1)

    y_axis=2*(y_axis/100)/1540*10^6; %
    
    if size(y_axis,1)>1
       y_axis(Line_to_show,:) = y_axis(Line_to_show,:)-min(y_axis(Line_to_show,:));
    else
       y_axis = y_axis-min(y_axis);
    end    

else if (scale_in_us==2)
    
    y_axis=(2*(y_axis/100)/1540*10^6)/(HEADER{1, 1}.Sampling_period_ns/1000);
    
    if size(y_axis,1)>1
      y_axis(Line_to_show,:) = y_axis(Line_to_show,:)-min(y_axis(Line_to_show,:));
    else
      y_axis = y_axis-min(y_axis);
    end    

    end
end

if (mean2(RF_frame_Q)==0)
    flag2=-1; 
else 
    flag2=4;
end


if (I_Q_show == 2)
cla

if size(y_axis,1)>1
plot(y_axis(Line_to_show,1:1:end),RF_frame(1:1:end,Line_to_show),'g')
hold on

if (flag2==4)
plot(y_axis(Line_to_show,1:1:end),RF_frame_Q(1:1:end,Line_to_show),'r')
end

if (flag == 1) 
plot(y_axis(Line_to_show,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k')
end

x_range=[min(y_axis(Line_to_show,:)) max(y_axis(Line_to_show,:))];
y_range=[min(RF_frame(:)) max(RF_frame(:))];
else
plot(y_axis(1,1:1:end),RF_frame(1:1:end,Line_to_show),'g')
if (flag2==4)
hold on    
plot(y_axis(1,1:1:end),RF_frame_Q(1:1:end,Line_to_show),'r')
end
hold on

if (flag == 1)
plot(y_axis(1,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k') 
end
hold off

x_range=[min(y_axis(:,:)) max(y_axis(:,:))];
y_range=[min(RF_frame(:)) max(RF_frame(:))];       
end

if (scale_in_us==1)
    xlabel('Time, \mus','FontSize',10,'FontWeight','Bold')

else if (scale_in_us==2)
    xlabel('Samples','FontSize',10,'FontWeight','Bold')
else
    xlabel('Depth, cm','FontSize',10,'FontWeight','Bold')
end
end
ylabel('a.u.','FontSize',10,'FontWeight','Bold')

xlim(x_range)
% ylim(y_range)
zoom(gcf,'reset')

% axis tight

% http://undocumentedmatlab.com/blog/determining-axes-zoom-state

title(['Line #', num2str(Line_to_show)],'FontSize',10,'FontWeight','Bold')
%legend({'RF signal', 'Envelope'},'FontSize',10,'FontWeight','Bold')

if (flag==1 && flag2 == 4)
legend({'I','Q','Envelope'},'FontSize',10,'FontWeight','Bold')

else if (flag==1 && flag2 ~= 4)
       legend({'RF signal','Envelope'},'FontSize',10,'FontWeight','Bold')
    else if (flag~=1 && flag2 == 4) 
       legend({'I','Q'},'FontSize',10,'FontWeight','Bold')
    else
       legend({'RF signal'},'FontSize',10,'FontWeight','Bold')
    end
end
end

end

if (I_Q_show == 1)

cla 

if size(y_axis,1)>1
hold on
if (flag2==4)
plot(y_axis(Line_to_show,1:1:end),RF_frame_Q(1:1:end,Line_to_show),'r')
end

if (flag == 1) 
plot(y_axis(Line_to_show,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k')
end

x_range=[min(y_axis(Line_to_show,:)) max(y_axis(Line_to_show,:))];
y_range=[min(RF_frame_Q(:)) max(RF_frame_Q(:))];
else
if (flag2==4)
hold on    
plot(y_axis(1,1:1:end),RF_frame_Q(1:1:end,Line_to_show),'r')
end
hold on

if (flag == 1)
plot(y_axis(1,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k') 
end
hold off
x_range=[min(y_axis(:,:)) max(y_axis(:,:))];
y_range=[min(RF_frame_Q(:)) max(RF_frame_Q(:))];       
end

if (scale_in_us==1)
    xlabel('Time, \mus','FontSize',10,'FontWeight','Bold')

else if (scale_in_us==2)
    xlabel('Samples','FontSize',10,'FontWeight','Bold')
else
    xlabel('Depth, cm','FontSize',10,'FontWeight','Bold')
end
end
ylabel('a.u.','FontSize',10,'FontWeight','Bold')

xlim(x_range)
ylim(y_range)
zoom(gcf,'reset')

% axis tight

% http://undocumentedmatlab.com/blog/determining-axes-zoom-state

title(['Line #', num2str(Line_to_show)],'FontSize',10,'FontWeight','Bold')
%legend({'RF signal', 'Envelope'},'FontSize',10,'FontWeight','Bold')

if (flag==1 && flag2 == 4)
legend({'Q','Envelope'},'FontSize',10,'FontWeight','Bold')

else if (flag==1 && flag2 ~= 4)
       legend({'RF signal','Envelope'},'FontSize',10,'FontWeight','Bold')
    else if (flag~=1 && flag2 == 4) 
       legend({'Q'},'FontSize',10,'FontWeight','Bold')
    else
       legend({'RF signal'},'FontSize',10,'FontWeight','Bold')
    end
end
end

end

if (I_Q_show == 0)

cla

if size(y_axis,1)>1
plot(y_axis(Line_to_show,1:1:end),RF_frame(1:1:end,Line_to_show),'g')
hold on

if (flag == 1) 
plot(y_axis(Line_to_show,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k')
end

x_range=[min(y_axis(Line_to_show,:)) max(y_axis(Line_to_show,:))];
y_range=[min(RF_frame(:)) max(RF_frame(:))];
else
plot(y_axis(1,1:1:end),RF_frame(1:1:end,Line_to_show),'g')

hold on

if (flag == 1)
plot(y_axis(1,1:1:end),envelope_detection(RF_frame(1:1:end,Line_to_show)),'k') 
end
hold off

x_range=[min(y_axis(:,:)) max(y_axis(:,:))];
y_range=[min(RF_frame(:)) max(RF_frame(:))];       
end

if (scale_in_us==1)
    xlabel('Time, \mus','FontSize',10,'FontWeight','Bold')

else if (scale_in_us==2)
    xlabel('Samples','FontSize',10,'FontWeight','Bold')
else
    xlabel('Depth, cm','FontSize',10,'FontWeight','Bold')
end
end
ylabel('a.u.','FontSize',10,'FontWeight','Bold')

xlim(x_range)
% ylim(y_range)
zoom(gcf,'reset')

% axis tight

% http://undocumentedmatlab.com/blog/determining-axes-zoom-state

title(['Line #', num2str(Line_to_show)],'FontSize',10,'FontWeight','Bold')
%legend({'RF signal', 'Envelope'},'FontSize',10,'FontWeight','Bold')

if (flag==1 && flag2 == 4)
legend({'I','Envelope'},'FontSize',10,'FontWeight','Bold')

else if (flag==1 && flag2 ~= 4)
       legend({'RF signal','Envelope'},'FontSize',10,'FontWeight','Bold')
    else if (flag~=1 && flag2 == 4) 
       legend({'I'},'FontSize',10,'FontWeight','Bold')
    else
       legend({'RF signal'},'FontSize',10,'FontWeight','Bold')
    end
end
end

end

set(gca,'Layer','top')
set(gca,'fontsize',10) 

Y_lims = get(gca, {'ylim'});

%set(gca,'xLimMode','Auto') 
%set(gca,'yLimMode','Auto') 

% set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 12 7.5])
% print('-dtiff','-r1000', 'B_mode_image')

hold off


