function out=band_pass_filter(in, low_freq_cutoff, up_freq_cutoff, Sampling_frequency,flag)
%% Bandpass filter for RF signals (function for single frame)
% IN: in - RF frame (N  M), where N  number of samples, M  number of scanning lines (rows).
%     low_freq_cuttoff - lower cutoff frequency
%     up_freq_cuttoff - upper cutoff frequency 
%     Sampling_frequency
%     order - tap of the filter
%     flag - for band-pass (BP) filter type selection 0 for infinite impulse response (Butterworth type), 1 - for finite impulse response (FIR filter designed using the window method), 2 - turns of the filters 

% OUT: out - filtered RF frame
    
if (flag==0)    
order=4; % order of the filter (for bandpass 2*order)
[b,a] = butter(order,[low_freq_cutoff/(Sampling_frequency/2) up_freq_cutoff/(Sampling_frequency/2)], 'bandpass');

for i=1:size(in,2) 
out(:,i) = filtfilt(b,a,in(:,i));
end

else if (flag==1)
  
order=200; % order of the filter (for bandpass 2*order)      
if length(in)>3*order
    order=200; % order of the filter (for bandpass 2*order)
else
    order=100;   
end

b=fir1(order,[low_freq_cutoff/(Sampling_frequency/2) up_freq_cutoff/(Sampling_frequency/2)], 'bandpass');    

% figure
% freqz(b,1,[],Sampling_frequency)
% pause

for i=1:size(in,2) 
out(:,i) = filtfilt(b,1,in(:,i));
end

else
out = in;
   end
end


