function out = speckle_filter(Vq,N, sigma_n, iteration_num)

%% IN:
% N - tap of the filter
% sigma_n - noise variance parameter
% iteration_num - number of iterations
%% OUT:
% out - outputs filtered B mode image

Vq = padarray(Vq,[N N],'symmetric');

out = Vq; 
for n=1:iteration_num % number of filtering iterations
for i = 1:size(out,1)-N
   for j = 1:size(out,2)-N
       
   fragment = out(i:i+N-1,j:j+N-1);
   variance = var(fragment(:));
   k_coeff = (variance)/(variance+sigma_n);
   
   if k_coeff<0
       k_coeff=0;
   end
   
   out(i,j)=mean2(fragment)+k_coeff*(Vq(i+(N-1)/2,j+(N-1)/2)-mean2(fragment));
  

   end
end
end

out(end-2*N+1:end,:) = [];
out(:,end-2*N+1:end) = [];


